// The MIT License (MIT)
//
// Copyright (c) 2018 Mateusz Pusz
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all
// copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.

#pragma once

#include <units/physical/dimensions/absorbed_dose.h>
#include <units/physical/dimensions/acceleration.h>
#include <units/physical/dimensions/amount_of_substance.h>
#include <units/physical/dimensions/angular_velocity.h>
#include <units/physical/dimensions/area.h>
#include <units/physical/dimensions/capacitance.h>
#include <units/physical/dimensions/catalytic_activity.h>
#include <units/physical/dimensions/charge_density.h>
#include <units/physical/dimensions/concentration.h>
#include <units/physical/dimensions/conductance.h>
#include <units/physical/dimensions/current_density.h>
#include <units/physical/dimensions/density.h>
#include <units/physical/dimensions/dynamic_viscosity.h>
#include <units/physical/dimensions/electric_charge.h>
#include <units/physical/dimensions/electric_current.h>
#include <units/physical/dimensions/electric_field_strength.h>
#include <units/physical/dimensions/energy.h>
// TODO Add when downcasting issue is solved
// #include <units/physical/dimensions/energy_density.h>
#include <units/physical/dimensions/force.h>
#include <units/physical/dimensions/frequency.h>
#include <units/physical/dimensions/heat_capacity.h>
#include <units/physical/dimensions/inductance.h>
#include <units/physical/dimensions/length.h>
#include <units/physical/dimensions/luminance.h>
#include <units/physical/dimensions/luminous_intensity.h>
#include <units/physical/dimensions/magnetic_flux.h>
#include <units/physical/dimensions/magnetic_induction.h>
#include <units/physical/dimensions/mass.h>
#include <units/physical/dimensions/molar_energy.h>
#include <units/physical/dimensions/momentum.h>
#include <units/physical/dimensions/permeability.h>
#include <units/physical/dimensions/permittivity.h>
#include <units/physical/dimensions/power.h>
#include <units/physical/dimensions/pressure.h>
// TODO Add when downcasting issue is solved
// #include <units/physical/dimensions/radioactivity.h>
#include <units/physical/dimensions/resistance.h>
#include <units/physical/dimensions/speed.h>
#include <units/physical/dimensions/surface_tension.h>
#include <units/physical/dimensions/thermal_conductivity.h>
#include <units/physical/dimensions/thermodynamic_temperature.h>
#include <units/physical/dimensions/time.h>
#include <units/physical/dimensions/torque.h>
#include <units/physical/dimensions/voltage.h>
#include <units/physical/dimensions/volume.h>
